package intro2java;
import robocode.*;

public class DamageReporter extends Robot
{
	private DamageReport[] _reports;
	private int _count;
	
	public DamageReporter()
	{
		_count = 0;
	}
	
	/**
	 * run: DamageReporter's default behavior
	 */
	public void run() {
		_reports = new DamageReport[ getOthers() ];
		// After trying out your robot, try uncommenting the import at the top,
		// and the next line:
		//setColors(Color.red,Color.blue,Color.green);
		while(true) {
			// Replace the next 4 lines with any behavior you would like
			ahead(100);
			turnGunRight(360);
			back(100);
			turnGunRight(360);
		}
	}

	/**
	 * onHitByBullet: What to do when you're hit by a bullet
	 */
	public void onHitByBullet(HitByBulletEvent e) 
	{
		DamageReport report = null;
		if (_count > 0)
		{
			for (int i=0; i<_count; i++)
			{
				if (_reports[i].getEnemyName().equals( e.getName() ) )
				{
					report = _reports[i];
				}
			}
		}
		if (report == null)
		{
			report = new DamageReport(e.getName());
			_reports[_count] = report;
			_count++;			
		}
		
		report.addDamage( e.getPower() );
	}
	
	public void onWin(WinEvent win)
	{
		printDamageReport();
	}
	
	public void onDeath(DeathEvent death)
	{
		printDamageReport();
	}
	
	public void printDamageReport()
	{
		for (int i=0; i<_count; i++)
		{
			DamageReport report = _reports[i];
			out.println("Damage from " + report.getEnemyName() + " = " + report.getTotalDamage() );
		}
	}
}
