package intro2java;
import robocode.*;

public class MovementFollower extends Robot
{
	private Movement[] _directions;
	
	public MovementFollower()
	{
		_directions = new Movement[5];
		_directions[0] = new Movement(Movement.FORWARD, 100);
		_directions[1] = new Movement(Movement.LEFT, 50);
		_directions[2] = new Movement(Movement.LEFT, 50);
		_directions[3] = new Movement(Movement.RIGHT, 100);
		_directions[4] = new Movement(Movement.BACKWARD, 20);
	}
	
	public void run() {
		while(true) 
		{
			for (int i=0; i<_directions.length; i++)
			{
				doMovement(_directions[i]);
			}
		}
	}

	private void doMovement(Movement movement)
	{
		int direction = movement.getDirection();
		if (direction == Movement.FORWARD)
		{
			ahead(movement.getDistance());
		}
		if (direction == Movement.BACKWARD)
		{
			back(movement.getDistance());
		}
		if (direction == Movement.LEFT)
		{
			turnLeft(90);
			ahead(movement.getDistance());
		}		
		if (direction == Movement.RIGHT)
		{
			turnRight(90);
			ahead(movement.getDistance());
		}		
	}	
}
